/* edgeConnect.cc */
/* $Lastupdate: Fri Nov 25 15:23:28 2005 $ */

/*

[ץ̾]

edgeConnect.cc

[򤹤ץफ]

edgeConnect.cc ϡedge format V.4 ǡåȤ顢
å³ɽǡå edge connection V.4 
ץǤ

[Ȥ]

(1) ʤǵư :

% edgeConnect
# edge format V.4 data (input file) : iFile
# edge connection V.4 data (output file) : oFile

(2) Ĥǵư :

% edgeConnect iFile oFile

  o iFile : edge format V.4 ǡå (ϥե)
  o oFile : edge connection V.4 ǡå (ϥե)

[ϥեΥեޥå]

edge format V.4

@begin{sample.iEdge} ----------------------------------------------
[Comment]
This dataset was generated from sample.iEdge and sample.iNode by toEdgeFmt.
[Data Format Name]
edge format V.4
[Number of BBEdges]
4
[Number of BREdges]
1
[Number of RREdges]
2
[Number of Total Edges]
7
[Data]
1 1 0 30 30 2 20 10 10 1 34.4 0.581395 100
2 3 20 30 30 2 20 10 10 1 28.3 0.706714 100
3 2 20 10 10 5 20 0 0 1 14.1 0.70922 100
4 4 40 20 20 5 20 0 0 1 34.4 0.581395 100
5 5 20 0 0 6 20 0 0 2 
6 7 0 0 0 6 20 0 0 3 20 0
7 6 20 0 0 8 30 0 0 3 10 0
@end{sample.iEdge} ------------------------------------------------

[ϥեΥեޥå]

edge connection V.4

@begin{sample.oEdge} ---------------------------------------------
[Comment]
This dataset was generated from sample.iEdge and sample.iNode by toEdgeFmt.
This data was generated from sample.iEdge by edgeConnect.
[Data Format Name]
edge connection V.4
[Number of BBEdges]
4
[Number of BREdges]
1
[Number of RREdges]
2
[Number of Total Edges]
7
[Data]
1 1 0 30 30 2 20 10 10 0 2 -3 2 1 34.4 0.581395 100
2 3 20 30 30 2 20 10 10 0 2 -3 1 1 28.3 0.706714 100
3 2 20 10 10 5 20 0 0 2 2 1 2 -5 4 1 14.1 0.70922 100
4 4 40 20 20 5 20 0 0 0 2 -5 3 1 34.4 0.581395 100
5 5 20 0 0 6 20 0 0 2 3 4 2 -7 6 2 
6 7 0 0 0 6 20 0 0 0 2 -7 5 3 20 0
7 6 20 0 0 8 30 0 0 2 5 6 0 3 10 0
@end{sample.oEdge} -----------------------------------------------

[ѥ]

% make

[¾]

ϥե˽񤭽Ф륨åֹϡϥե˽񤫤
ֹ椬Τޤ¸ޤ

*/

#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <assert.h>
#include <stdlib.h>				// for getopt, rand
#include <unistd.h>

#include "khboolean.h"
#include "khsimple.h"
#include "kherror.h"
#include "khslist.h"
#include "khslist.cc"
#include "khstr.h"
#include "khbintree.h"
#include "khbintree.cc"

#include "nopath.h"				// for nopath

template class KhSListDynamic<long>;

class Edge
{
	long num;					// åֹ

	long upperNode;				// ήΡֹ
	long lowerNode;				// ήΡֹ

// 	// added at Tue Nov 23 20:36:21 1999
// 	double x, y, z;				// κɸ

	double upx, upy, upz;		// ήΡɤκɸ
	double lowx, lowy, lowz;	// ήΡɤκɸ

	int atr;					// å°
								// 1 : ή-ήå
								// 2 : ή-ƻå
								// 3 : ƻ-ƻå

	double len;					// åĹ
	double grd;					// åθ
	double area;				// å

	KhSListDynamic<long> upperEdgeList;	// ή¦åֹ
	KhSListDynamic<long> lowerEdgeList;	// ή¦åֹ

  public:

	void Init(long wnum, 
			  long wupperNode, double wupx, double wupy, double wupz, 
  			  long wlowerNode, double wlowx, double wlowy, double wlowz, 
			  int watr, double wlen, double wgrd, double warea)
	{
		num = wnum; 
		upperNode = wupperNode; upx = wupx; upy = wupy; upz = wupz;
		lowerNode =	wlowerNode; lowx = wlowx; lowy = wlowy; lowz = wlowz;
		atr = watr; len = wlen; grd = wgrd; area = warea;
	}

	Edge(void) {}

	~Edge(void) { upperEdgeList.Erase(); lowerEdgeList.Erase(); }

  public:

	long Number(void) { return num; }
	double UpX(void) { return upx; }
	double UpY(void) { return upy; }
	double UpZ(void) { return upz; }
	double LowX(void) { return lowx; }
	double LowY(void) { return lowy; }
	double LowZ(void) { return lowz; }
	long UpperNode(void) { return upperNode; }
	long LowerNode(void) { return lowerNode; }
	int Atribute(void) { return atr; }
	double Length(void) { return len; }
	double Gradient(void) { return grd; }
	double Area(void) { return area; }

  public:

	// Edge ֹ list ɲä
	void AddUpperEdge(long wedge) { upperEdgeList.Append(wedge); }
	void AddLowerEdge(long wedge) { lowerEdgeList.Append(wedge); }

	// ѱ黻Ҥκ
	friend ofstream& operator<<(ofstream& os, Edge wedge);
	friend ostream& operator<<(ostream& os, Edge wedge);

};

ofstream& operator<<			// Edge ǡν
(
	ofstream& os,				// ϥȥ꡼
 	Edge wedge					// Edge ǡ
)
{
	KhBoolean r;

	// åֹν
	os << wedge.Number() << " " ;

	// üΡֹν
	os << wedge.UpperNode() << " " ;

	// üΡɤκɸν
	os << wedge.UpX() << " " ;
	os << wedge.UpY() << " " ;
	os << wedge.UpZ() << " " ;

	// üΡֹν
	os << wedge.LowerNode() << " " ;

	// üΡɤκɸν
	os << wedge.LowX() << " " ;
	os << wedge.LowY() << " " ;
	os << wedge.LowZ() << " " ;

	// upperEdgeList ν
	os << wedge.upperEdgeList.GetCount() << " ";
	for (r = wedge.upperEdgeList.ToHead(); r == YES; 
		 r = wedge.upperEdgeList.ToNext()) {
		os << wedge.upperEdgeList.Get() << " "  ;
	}

	// lowerEdgeList ν
	os << wedge.lowerEdgeList.GetCount() << " ";
	for (r = wedge.lowerEdgeList.ToHead(); r == YES; 
		 r = wedge.lowerEdgeList.ToNext()) {
		os << wedge.lowerEdgeList.Get() << " "  ;
	}

	// å°ν
	os << wedge.Atribute() << " " ;

	// åĹۡѤν
	if (wedge.Atribute() == 1)
		os << wedge.Length() << " " << wedge.Gradient() << " "
		   << wedge.Area() ;
	else if (wedge.Atribute() == 3)
		os << wedge.Length() << " " << wedge.Gradient() ;

	return os;
}

ostream& operator<<			// Edge ǡν
(
	ostream& os,				// ϥȥ꡼
 	Edge wedge					// Edge ǡ
)
{
	KhBoolean r;

	// åֹν
	os << wedge.Number() << " " ;

	// üΡֹν
	os << wedge.UpperNode() << " " ;

	// üΡɤκɸν
	os << wedge.UpX() << " " ;
	os << wedge.UpY() << " " ;
	os << wedge.UpZ() << " " ;

	// üΡֹν
	os << wedge.LowerNode() << " " ;

	// üΡɤκɸν
	os << wedge.LowX() << " " ;
	os << wedge.LowY() << " " ;
	os << wedge.LowZ() << " " ;

	// upperEdgeList ν
	os << wedge.upperEdgeList.GetCount() << " ";
	for (r = wedge.upperEdgeList.ToHead(); r == YES; 
		 r = wedge.upperEdgeList.ToNext()) {
		os << wedge.upperEdgeList.Get() << " "  ;
	}

	// lowerEdgeList ν
	os << wedge.lowerEdgeList.GetCount() << " ";
	for (r = wedge.lowerEdgeList.ToHead(); r == YES; 
		 r = wedge.lowerEdgeList.ToNext()) {
		os << wedge.lowerEdgeList.Get() << " "  ;
	}

	// åĹۡѤν
	os << wedge.Length() << " " << wedge.Gradient() << " "
	   << wedge.Area() << endl;

	return os;
}

class WorkNode
{
  	long edgeNum;
	long nodeNum;

  public:

	long EdgeNum(void) { return edgeNum; }
	long NodeNum(void) { return nodeNum; }

	void Init(long wedgeNum = 0, long wnodeNum = 0)
	{
		edgeNum = wedgeNum;
		nodeNum = wnodeNum;
	}
		 
	WorkNode(long wedgeNum = 0, long wnodeNum = 0)
	{ Init(wedgeNum, wnodeNum); }

	WorkNode& operator = (const WorkNode& someNode)
	{
		if (this != &someNode)
		{
			edgeNum = someNode.edgeNum;
			nodeNum = someNode.nodeNum;
		}
		return *this;
	}

	int operator < (const WorkNode& someNode) const
	{
		return (nodeNum < someNode.nodeNum);
	}

	int operator == (const WorkNode& someNode) const
	{
		return ((edgeNum == someNode.edgeNum)
				&& (nodeNum == someNode.nodeNum));
	}

};

template <class D>
class KhBinaryTree2 : public KhBinaryTree<D>
{
  public:

	KhTreeNode<D>* GetPtrToNode(const D & item)
	{ return Search(item); }

	KhTreeNode<D>* WrapInternalInsert(const D & item)
	{ return InternalInsert(item); }
};

template <class D>
class KhBinaryTreeIterator2 : public KhBinaryTreeIterator<D>
{
  public:

	KhBinaryTreeIterator2(KhBinaryTree<D> & bt);

	void Init(KhTreeNode<D>* p)
	{ KhBinaryTreeIterator<D>::Node = p; }

};

template <class D>
KhBinaryTreeIterator2<D>::KhBinaryTreeIterator2(KhBinaryTree<D> & bt)
: KhBinaryTreeIterator<D>(bt)
{}

template class KhBinaryTree<WorkNode>;

void usage(const KhString& command)
{
  cerr
  << "\n" << command << " produces edge connection data\n"
  << "usage: " << command << " [options] [iFile] [oFile]\n"
  << "  options: \n"
  << "    -h  show this help message\n"
  << "    -v  show version number\n"
  << "  iFile : edge format data V.1\n"
  << "  oFile : edge connection data\n"
  << "  If \"iFile\" and \"oFile\" are given in the command line, \n"
  << "  the input data are read in from the file.\n"
  << "  Otherwise, the input data are read in from STDIN\n"
  << "  with giving prompting messages.\n" << endl;
  exit(1);
}

void version(void)
{
	cerr << "\nThis is edgeConnect\n"
		 << "developed by Yutaka ICHIKAWA, Kyoto Univ.\n" << endl;
}

// Хʥĥ꡼θ®뤿ι()

// 0.0 <= rnd() < 1.0 ΰ
// Cˤ륢르ꥺŵ, ¼ɧ, ɾ,
// pp. 294--298

#define rnd() (1.0 / (RAND_MAX + 1.0)) * rand()

// Хʥĥ꡼˳Ǽ򥷥åե뤷ơ
// ĥ꡼Ф꤬Фʤ褦ˤ롣

void Shuffle					// 򥷥åե뤹
(
	long n,						// ǿ
	WorkNode* v					// 
)
{
	long i, j;
	WorkNode t;

	for (i = n - 1; i > 0; i--)
	{
		j = (long)((i+1) * rnd());
		t = v[i]; v[i] = v[j]; v[j] = t;
	}
}

int main						// ᥤץ
(
	int argc,
 	char** argv
)
{

	KhString command = nopath(argv[0]);

  	// optstring ǡץȤƵʸꤷޤ
	char *optstring = "hv";

	int c;
	while((c = getopt(argc, argv, optstring)) != EOF)
	{
    	// getopt ϲϤץʸ֤ޤ
		switch (c) {
		  case 'v':
			version();
			break;
		  case 'h':
			// ץʸ h ֤Ƥν
			// fall through
		  default:
			usage(command);
		}
	}

	// argc ˤ, ޥ̾ȰθĿޤĤʤ
	// Ȥargc ˤ 1 ޤ

	if (argc != 1 && argc != 3)
	{
		//  command ǤϡθĿ2Ĥޤ0ĤǤ
		usage(command);
	}

	// ϥե̾
	char in[256], out[256];
	if (argc == 1) {
		cout << "# edge format V.4 data (input file) : ";
		cin >> in;
		cout << "# edge connection V.4 data (output file) : ";
		cin >> out;
	}
	else {
		istringstream istri(argv[1]);
		istri >> in;
		istringstream istro(argv[2]);
		istro >> out;
	}

	ifstream iFile(in);
	ofstream oFile(out);

	KhString buf;

	// [Comment] Ϥ
//	while (getline(iFile, buf) && buf != dataFormatName)
	while (getline(iFile, buf) && 
 		   strncmp((const char *)buf, "[Data Format Name]", 18) != 0)
		oFile << buf << endl;
	oFile << "This data was generated from " << in 
		  << " by " << command << "." << endl;

	// [Data Format Name] Ϥ
	oFile << buf << endl;
	getline(iFile, buf);
//	if (buf != "edge format V.2")
	if (strncmp((const char *)buf, "edge format V.4", 15) != 0)
	{
		kherror();
		cerr << "iFile must be edge format V.4 data." << endl;
		exit(1);
	}
	oFile << "edge connection V.4" << endl;

	// ϥե [Number of Total Edges] ޤǥåפ
// 	while (getline(iFile, buf) && buf != "[Number of Total Edges]")
	while (getline(iFile, buf) && 
		   strncmp((const char *)buf, "[Number of Total Edges]", 23) != 0)
		oFile << buf << endl;

// 	if (buf != "[Number of Total Edges]") kherror();
	if (strncmp((const char *)buf, "[Number of Total Edges]", 23) != 0) 
		kherror();
	oFile << buf << endl;

	// Number of Total Edges ɤ߹ߡåȥΡɤ
	// 
	long numEdges;
	getline(iFile, buf); oFile << buf << endl;
// 	istrstream strmbuf(buf);
	istringstream strmbuf((const char *)buf);
	strmbuf >> numEdges;

	Edge* edgeArray = new Edge[numEdges];
	WorkNode* upperNodeArray = new WorkNode[numEdges];
	WorkNode* lowerNodeArray = new WorkNode[numEdges];

	// ϥե [Data] ޤǥåפ
// 	while (getline(iFile, buf) && buf != "[Data]") ;
	while (getline(iFile, buf) && 
		   strncmp((const char *)buf, "[Data]", 6) != 0) ;
// 	if (buf != "[Data]") kherror();
	if (strncmp((const char *)buf, "[Data]", 6) != 0) kherror();
	oFile << buf << endl;

	// åΥǡ edgeArray , upperNode Υǡ
	// upperNodeArray , lowerNode Υǡ lowerNodeArray 
	// 줾ɤ߹ߡˡupperNodeArray, lowerNodeArray 
	// Хʥĥ꡼˼Ͽ

	long wnum; 
	double wupx, wupy, wupz;
	double wlowx, wlowy, wlowz;
	long wupperNode, wlowerNode; int watr;
	double wlen, wgrd, warea;

	KhBinaryTree2<WorkNode> 
		tree_upperNode, // upperNode ΥХʥĥ꡼
		tree_lowerNode;	// lowerNode ΥХʥĥ꡼

	for (long i = 0; i < numEdges; i++)
	{
		if (!getline(iFile, buf))
		{
			kherror();
			cerr << i+1 << "th data" << endl;
			exit(1);
		}

// 		istrstream strmbuf(buf);
		istringstream strmbuf((const char *)buf);
// 		strmbuf >> wnum >> wx >> wy >> wz >> wupperNode >> wlowerNode >> watr;

		// edge format V.4 б
		strmbuf >> wnum >> wupperNode >> wupx >> wupy >> wupz 
				>> wlowerNode >> wlowx >> wlowy >> wlowz >> watr;

		if (watr == 1) 
			strmbuf >> wlen >> wgrd >> warea;
		else if (watr == 2) 
			wlen = wgrd = warea = -1.0;
		else if (watr == 3)
		{
			strmbuf >> wlen >> wgrd; warea = -1.0;
		}
		else 
			kherror();

		edgeArray[i].Init(wnum, 
						  wupperNode, wupx, wupy, wupz, 
						  wlowerNode, wlowx, wlowy, wlowz, 
						  watr, wlen, wgrd, warea);

		upperNodeArray[i].Init(wnum, wupperNode);
//		tree_upperNode.Insert(upperNodeArray[i]);

		lowerNodeArray[i].Init(wnum, wlowerNode);
//		tree_lowerNode.Insert(lowerNodeArray[i]);
	}

	cout << "trees has been built." << endl;

	// 򥷥åե뤹
	Shuffle(numEdges, upperNodeArray);
	Shuffle(numEdges, lowerNodeArray);

	for (long i = 0; i < numEdges; i++)
	{
		tree_upperNode.Insert(upperNodeArray[i]);
		tree_lowerNode.Insert(lowerNodeArray[i]);
	}

	// 岼ή³Ƥ륨åõ
	long targetNode;
	for (long i = 0; i < numEdges; i++)
	{
		WorkNode workUpperNode(edgeArray[i].Number(),
							   edgeArray[i].UpperNode());
		WorkNode workLowerNode(edgeArray[i].Number(),
							   edgeArray[i].LowerNode());

		KhTreeNode<WorkNode> *p;

		// (1a) tree_lowerNode ή¦ήåõ

		/// ޤʬȤ
		p = tree_lowerNode.WrapInternalInsert(workUpperNode);

 		KhBinaryTreeIterator2<WorkNode>* itr1a =
			new KhBinaryTreeIterator2<WorkNode>(tree_lowerNode);

// 		// for debugging
// 		while ((WorkNode*)itr1a[0])
// 		{
// 			WorkNode node = *itr1a[0];
// 			cout << node.EdgeNum() << " : " << node.NodeNum() << endl;
// 			++itr1a[0];
// 		}
// 
// 		cout << endl;
// 		delete itr1a;

		//// ʬ˳ǼƤΡɤõ
		itr1a[0].Init(p); --itr1a[0];
		targetNode = p->Data.NodeNum();
		while (itr1a[0] && (WorkNode)(*itr1a[0]).NodeNum() == targetNode)
		{
			WorkNode node = (WorkNode)*itr1a[0];
			edgeArray[i].AddUpperEdge(node.EdgeNum());
			--itr1a[0];
		}
 		delete itr1a;				// ƥ졼ä

		///// ʬȤä
		tree_lowerNode.Delete(workUpperNode);

//		cout << i+1 << " : 1a" << endl;

		// (1b) tree_upperNode ή¦ήХåõ

		/// ޤʬȤõ
		p = tree_upperNode.GetPtrToNode(workUpperNode);

 		KhBinaryTreeIterator2<WorkNode>* itr1b =
			new KhBinaryTreeIterator2<WorkNode>(tree_upperNode);

		//// ʬ˳ǼƤΡɤõ
		itr1b[0].Init(p); --itr1b[0];
		targetNode = p->Data.NodeNum();
		while (itr1b[0] && (WorkNode)(*itr1b[0]).NodeNum() == targetNode)
		{
			WorkNode node = (WorkNode)*itr1b[0];
			edgeArray[i].AddUpperEdge(-(node.EdgeNum()));
			--itr1b[0];
		}

		//// ʬ˳ǼƤΡɤõ
		itr1b[0].Init(p); ++itr1b[0];
		while (itr1b[0] && (WorkNode)(*itr1b[0]).NodeNum() == targetNode)
		{
			WorkNode node = (WorkNode)*itr1b[0];
			edgeArray[i].AddUpperEdge(-(node.EdgeNum()));
			++itr1b[0];
		}

 		delete itr1b;				// ƥ졼ä
//		cout << i+1 << " : 1b" << endl;

		// (2a) tree_upperNode 鲼ή¦ήХåõ

		/// ޤʬȤߡʬȤõ
		p = tree_upperNode.WrapInternalInsert(workLowerNode);

 		KhBinaryTreeIterator2<WorkNode>* itr2a =
			new KhBinaryTreeIterator2<WorkNode>(tree_upperNode);

		//// ʬ˳ǼƤΡɤõ
		itr2a[0].Init(p); --itr2a[0];
		targetNode = p->Data.NodeNum();
		while (itr2a[0] && (WorkNode)(*itr2a[0]).NodeNum() == targetNode)
		{
			WorkNode node = (WorkNode)*itr2a[0];
			edgeArray[i].AddLowerEdge(-(node.EdgeNum()));
			--itr2a[0];
		}
 		delete itr2a;				// ƥ졼ä

		///// ʬȤä
		tree_upperNode.Delete(workLowerNode);
//		cout << i+1 << " : 2a" << endl;

		// (2b) tree_lowerNode 鲼ή¦ήåõ

		/// ޤʬȤõ
		p = tree_lowerNode.GetPtrToNode(workLowerNode);

 		KhBinaryTreeIterator2<WorkNode>* itr2b =
			new KhBinaryTreeIterator2<WorkNode>(tree_lowerNode);

		//// ʬ˳ǼƤΡɤõ
		itr2b[0].Init(p); --itr2b[0];
		targetNode = p->Data.NodeNum();
		while (itr2b[0] && (WorkNode)(*itr2b[0]).NodeNum() == targetNode)
		{
			WorkNode node = (WorkNode)*itr2b[0];
			edgeArray[i].AddLowerEdge(node.EdgeNum());
			--itr2b[0];
		}

		//// ʬ˳ǼƤΡɤõ
		itr2b[0].Init(p); ++itr2b[0];
		while (itr2b[0] && (WorkNode)(*itr2b[0]).NodeNum() == targetNode)
		{
			WorkNode node = (WorkNode)*itr2b[0];
			edgeArray[i].AddLowerEdge(node.EdgeNum());
			++itr2b[0];
		}

 		delete itr2b;				// ƥ졼ä
//		cout << i+1 << " : 2b" << endl;

		cout << "edge " << i+1 << " done" << endl;
	}

	// ǡν
	for (long i = 0; i < numEdges; i++) 
	{
		oFile << edgeArray[i] << endl;
	}

	return 0;
}
